/*
 * Created on 22 fvr. 2005
 */
package fr.improve.demoserveur.actions.addnews;

import java.io.IOException;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import fr.improve.demoserveur.actions.DemoServeurDeNewsDispatchAction;
import fr.improve.demoserveur.actions.NewsForm;
import fr.improve.demoserveur.database.Database;
import fr.improve.demoserveur.database.Subject;

/**
 * @author Jean Noel Ribette,David Duarte
 */
public class AddNewsAction extends DemoServeurDeNewsDispatchAction {
	public ActionForward prepareAddNewsForm(ActionMapping mapping,
			ActionForm form, HttpServletRequest request,
			HttpServletResponse response) throws IOException, ServletException {
		String l_result = "index";
		NewsForm l_loginForm = (NewsForm) form;
		Database l_database = Database.getDataBase();
		int l_nbNews = l_database.getAllNews().size();
		l_loginForm.setId(Integer.toString(l_nbNews));
		request.setAttribute("subjects", l_database.getAllSubjects());
		return mapping.findForward("addNewsForm");
	}

	public ActionForward prepareAddNewsFormTabs(ActionMapping mapping,
			ActionForm form, HttpServletRequest request,
			HttpServletResponse response) throws IOException, ServletException {
		String l_result = "index";
		NewsForm l_loginForm = (NewsForm) form;
		Database l_database = Database.getDataBase();
		int l_nbNews = l_database.getAllNews().size();
		l_loginForm.setId(Integer.toString(l_nbNews));
		request.setAttribute("subjects", l_database.getAllSubjects());
		return mapping.findForward("addNewsFormTabs");
	}

	public ActionForward addNewsTabs(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws IOException, ServletException {
		ActionErrors lc_errors = form.validate(mapping, request);
		if (lc_errors.isEmpty()) {
			NewsForm l_newsForm = (NewsForm) form;
			Database l_database = Database.getDataBase();
			String l_title = l_newsForm.getTitle();
			String l_subjectId = l_newsForm.getSubject();
			Subject l_subject = l_database.getSubjectByPrimaryKey(l_subjectId);
			if (l_subject == null) {
				l_subject = l_database.getSubjectByName(l_subjectId);
			}
			if (l_subject == null) {
				ActionErrors errors = new ActionErrors();
				errors.add("subject", new ActionError("error.required"));
				saveErrors(request, lc_errors);
				return mapping.findForward("input.addnewstab");
			}
			String l_body = l_newsForm.getBody();
			String l_result = "list";
			l_database.addNews(l_title, l_subject, l_body);
			return mapping.findForward(l_result);
		} else {
			saveErrors(request, lc_errors);
			return mapping.findForward("input.addnewstab");

		}
	}

	public ActionForward addNews(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws IOException, ServletException {
		ActionErrors lc_errors = form.validate(mapping, request);
		if (lc_errors.isEmpty()) {
			NewsForm l_newsForm = (NewsForm) form;
			Database l_database = Database.getDataBase();
			String l_title = l_newsForm.getTitle();
			String l_subjectId = l_newsForm.getSubject();
			Subject l_subject = l_database.getSubjectByPrimaryKey(l_subjectId);
			if (l_subject == null) {
				l_subject = l_database.getSubjectByName(l_subjectId);
			}
			if (l_subject == null) {
				ActionErrors errors = new ActionErrors();
				errors.add("subject", new ActionError("error.required"));
				saveErrors(request, lc_errors);
				return mapping.findForward("input.addnews");
			}
			String l_body = l_newsForm.getBody();
			String l_result = "list";
			l_database.addNews(l_title, l_subject, l_body);
			return mapping.findForward(l_result);
		} else {
			saveErrors(request, lc_errors);
			return mapping.findForward("input.addnews");
		}
	}
	
    /**
     * Affiche une fentre de popup permettant de choisir le sujet.
     */
    public ActionForward popup(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    	request.setAttribute("subjects", Database.getDataBase().getAllSubjects());
    	return mapping.findForward("popup");
    }   

}