/*
 * Created on 22 fvr. 2005
 */
package fr.improve.demoserveur.actions.allnews;

import java.io.IOException;
import java.text.DateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Collection;
import java.util.Date;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.TreeMap;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.fgm.web.menu.MenuComponent;
import com.fgm.web.menu.MenuRepository;

import fr.improve.demoserveur.actions.DemoServeurDeNewsDispatchAction;
import fr.improve.demoserveur.actions.NewsForm;
import fr.improve.demoserveur.database.Database;
import fr.improve.demoserveur.database.News;
import fr.improve.demoserveur.database.Subject;

/**
 * @author Jean Noel Ribette,David Duarte
 */
public class AllNewsAction extends DemoServeurDeNewsDispatchAction {

	public ActionForward showAllNews(ActionMapping mapping, ActionForm form,
			HttpServletRequest request, HttpServletResponse response)
			throws IOException, ServletException {
		Database l_database = Database.getDataBase();
		Collection l_allNews = l_database.getAllNews();
		request.setAttribute("allNews", l_allNews);
		return mapping.findForward("list");
	}
	
	/**
     * Construit un treeview  partir de la liste des news.
     */
    public ActionForward treeview(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    	// Build the news map.
     	Map lc_map = new TreeMap();          	
     	Calendar lc_calendar = Calendar.getInstance();
     	Iterator lc_it = Database.getDataBase().getAllNews().iterator();
     	while (lc_it.hasNext()) {
     		News lc_news = (News) lc_it.next();
     		lc_calendar.setTime(lc_news.getDate());
	        lc_calendar.set(Calendar.HOUR, 0);
	        lc_calendar.set(Calendar.MINUTE,0);
	        lc_calendar.set(Calendar.SECOND,0);
	        lc_calendar.set(Calendar.MILLISECOND,0);
     		Map lc_innerMap = (Map) lc_map.get(lc_calendar.getTime());
     		if (lc_innerMap==null) {
     			lc_innerMap = new TreeMap();
     			lc_map.put(lc_calendar.getTime(), lc_innerMap);
     		}
     		List lc_list = (List) lc_innerMap.get(lc_news.getSubject());
     		if (lc_list==null) {
     			lc_list = new ArrayList();
     			lc_innerMap.put(lc_news.getSubject(), lc_list);
     		}
     		lc_list.add(lc_news);
     	}
     	
     	// Build the treeview.
     	MenuComponent lc_menu = new MenuComponent();
     	lc_menu.setName("news");
     	lc_it = lc_map.entrySet().iterator();
     	DateFormat lc_format = DateFormat.getDateInstance(DateFormat.SHORT, getLocale(request));
     	while (lc_it.hasNext()) {
     		Map.Entry lc_entry = (Map.Entry) lc_it.next();
     		MenuComponent lc_subject = new MenuComponent();
     		lc_subject.setTitle(lc_format.format((Date)lc_entry.getKey()));
     		lc_menu.addMenuComponent(lc_subject);
     		Iterator lc_it2 = ((Map)lc_entry.getValue()).entrySet().iterator();
     		while (lc_it2.hasNext()) {
     			Map.Entry lc_entry2 = (Map.Entry) lc_it2.next();
     			MenuComponent lc_title = new MenuComponent();
     			Subject lc_subjectBean = (Subject) lc_entry2.getKey();
     			lc_title.setTitle(lc_subjectBean.getName());
     			lc_subject.addMenuComponent(lc_title);
     			Iterator lc_it3 = ((List)lc_entry2.getValue()).iterator();
     			while (lc_it3.hasNext()) {
     				News lc_news = (News) lc_it3.next();
     				MenuComponent lc_newsItem = new MenuComponent();
     				lc_newsItem.setTitle(lc_news.getTitle());
     				lc_newsItem.setLocation("allNews.do?reqCode=treeview&newsId=" + lc_news.getId());
     				lc_title.addMenuComponent(lc_newsItem);
     			}
     		}
     	}
     	
     	// Put the treeview in the menu repository
     	MenuRepository lc_repository = (MenuRepository) request.getSession().getAttribute(MenuRepository.MENU_REPOSITORY_KEY);
     	if (lc_repository==null) {
     		lc_repository = new MenuRepository();
     		request.getSession().setAttribute(MenuRepository.MENU_REPOSITORY_KEY, lc_repository);
     	}
     	lc_repository.addMenu(lc_menu);
     	
     	// If a news is selected, display it.
     	String lc_newsId = request.getParameter("newsId");
     	if (lc_newsId!=null) {
     		News lc_news = Database.getDataBase().getNewsByPrimaryKey(lc_newsId);
     		NewsForm lc_form = (NewsForm) form;
     		lc_form.setId(lc_news.getId());
     		lc_form.setTitle(lc_news.getTitle());
     		lc_form.setSubject(lc_news.getSubject().getId());
     		lc_form.setBody(lc_news.getBody());
     		
	        request.setAttribute("subjects", Database.getDataBase().getAllSubjects());
     	}
     	
     	return mapping.findForward("treeview");
    }

}