package fr.improve.demoserveur.actions.masse;
import java.util.ArrayList;
import java.util.Collection;
import java.util.Iterator;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import fr.improve.demoserveur.actions.DemoServeurDeNewsDispatchAction;
import fr.improve.demoserveur.database.Database;
import fr.improve.demoserveur.database.News;

/**
 * Struts action class allowing to update several news title and subject at a time.
 * @author JN. Ribette
 */
public class MasseNewsAction extends DemoServeurDeNewsDispatchAction {
	/**
	 * Action which prepares the news list and forward to the updateHeaders jsp.
	 */
	public ActionForward edit(ActionMapping in_mapping, ActionForm in_form, HttpServletRequest in_request, HttpServletResponse in_response) {
    	// Get the news       
        Database l_database = Database.getDataBase();
        Collection l_allNews = l_database.getAllNews();               
        in_request.setAttribute("allNews", l_allNews);
        
        // Get the subject
		ArrayList l_list = new ArrayList();
        l_list.add(new SubjectBean("Apache", "apache"));
        l_list.add(new SubjectBean("Serveur d'applications", "appservers"));
        l_list.add(new SubjectBean("Un autre sujet", "autre"));
        in_request.setAttribute("subjects", l_list);
                     
        return in_mapping.findForward("view");
    }
 	/**
 	 * Action which get the news new titles from the form and modify the database.
 	 */   
    public ActionForward save(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {    	
        Database l_database = Database.getDataBase();
		Iterator lc_it = Database.getDataBase().getAllNews().iterator();
		MasseNewsForm lc_form = (MasseNewsForm) form;
		while (lc_it.hasNext()) {
			News lc_news = (News) lc_it.next();
			lc_news.setTitle(lc_form.getTitle(lc_news.getId()));
		}
        return mapping.findForward("list");
    }
    	
}
