/*
 * Created on 22 fvr. 2005
 */
package fr.improve.demoserveur.actions.searchnews;

import java.text.DateFormat;
import java.text.ParsePosition;
import java.util.Calendar;
import java.util.Date;
import java.util.Iterator;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import fr.improve.demoserveur.actions.DemoServeurDeNewsDispatchAction;
import fr.improve.demoserveur.actions.NewsForm;
import fr.improve.demoserveur.database.Database;
import fr.improve.demoserveur.database.News;

/**
 * @author Jean Noel Ribette,David Duarte
 */
public class SearchNewsAction extends DemoServeurDeNewsDispatchAction {

	/**
	 * Renvoi la liste des news paru  la date recherche.
	 */
	public ActionForward findByDateAndSubject(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
		NewsForm lc_form = (NewsForm) form;
		String lc_date = lc_form.getDate();
		String lc_subject = lc_form.getSubject();
		Date lc_parsedDate = null;
		// Parse la date
		if (lc_date!=null) {
			DateFormat lc_format = DateFormat.getDateInstance(DateFormat.SHORT, getLocale(request));
			ParsePosition lc_position = new ParsePosition(0);
			lc_parsedDate = lc_format.parse(lc_date, lc_position);
			if (lc_position.getErrorIndex()!=-1 || lc_position.getIndex()!=lc_date.length()) {
				lc_parsedDate = null;
			}
		}
		if (lc_parsedDate==null && (lc_subject==null || lc_subject.length()==0)) {
			return new ActionForward(mapping.getInput());
		} else {
			// Cherche les news
			Vector lc_newsList = new Vector(Database.getDataBase().getAllNews());
			Calendar lc_calendar = Calendar.getInstance();
			Calendar lc_lookedCalendar = null;
			if (lc_parsedDate!=null) {
	    		lc_lookedCalendar = Calendar.getInstance();
	    		lc_lookedCalendar.setTime(lc_parsedDate);
			}
			Iterator lc_it = lc_newsList.iterator();
			while (lc_it.hasNext()) {
				News lc_news = (News) lc_it.next();	
				lc_calendar.setTime(lc_news.getDate());
				boolean lc_remove = false;
				if (lc_lookedCalendar!=null) {
	    			if (lc_calendar.get(Calendar.DAY_OF_MONTH)!= lc_lookedCalendar.get(Calendar.DAY_OF_MONTH) ||
	    			lc_calendar.get(Calendar.MONTH)!= lc_lookedCalendar.get(Calendar.MONTH)
	    			||
	    			lc_calendar.get(Calendar.YEAR)!= lc_lookedCalendar.get(Calendar.YEAR)
	    			) {
	    				lc_remove = true;
	    			}
				}
				if (!lc_remove && lc_subject!=null && lc_subject.length()>0) {
					if (!lc_subject.equals(lc_news.getSubject().getName())) {
						lc_remove = true;	
					}
				}
				if (lc_remove) {
					lc_it.remove();	
				}    				
					
			}    		
			request.setAttribute("allNews", lc_newsList);
	    	return mapping.findForward("list");
		}
	}

	
    /**
     * Affiche une fentre de popup permettant de choisir le sujet.
     */
    public ActionForward popup(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) {
    	request.setAttribute("subjects", Database.getDataBase().getAllSubjects());
    	return mapping.findForward("popup");
    }   
}
