package fr.improve.demoserveur.actions.subjects;

import java.security.InvalidParameterException;
import java.util.Collection;
import java.util.Iterator;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.actions.DispatchAction;

import fr.improve.demoserveur.database.Database;
import fr.improve.demoserveur.database.Subject;
import fr.improve.struts.taglib.layout.datagrid.Datagrid;

/**
 * Subject Struts action clas
 * 
 * @author jnribette
 */
public class SubjectAction extends DispatchAction {
	
	/**
	 * View all the titles for Edit.
	 */
	public ActionForward edit(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		SubjectForm lc_form = (SubjectForm) form;
		
		// Get the subjects list.
		List lc_subjects = Database.getDataBase().getAllSubjects();
		
		// Create a new datagrid;
		Datagrid lc_datagrid = Datagrid.getInstance();
		
		// Initialize the datagrid and the form.
		lc_datagrid.setData(lc_subjects);
		lc_datagrid.setDataClass(Subject.class);
		lc_form.setSubjects(lc_datagrid);
		
		// Forward to the jsp. 	
		return mapping.findForward("edit");
	}
	
	/**
	 * Save the changes.
	 */
	public ActionForward save(ActionMapping mapping, ActionForm form, HttpServletRequest request, HttpServletResponse response) throws Exception {
		SubjectForm lc_form = (SubjectForm) form;
		
		// Get the datagrid.
		Datagrid lc_datagrid = lc_form.getSubjects();
		
		// Get the database.
		Database lc_database = Database.getDataBase();
		
		// Deal with new subjects.
		Collection lc_added = lc_datagrid.getAddedData();
		Iterator lc_it = lc_added.iterator();
		while (lc_it.hasNext()) {
			Subject lc_newSubject = (Subject) lc_it.next();
			// Save the new subject in the database, if there is not already a subject with this name.
			if (lc_database.getSubjectByName(lc_newSubject.getName())==null) {
				lc_database.addSubject(lc_newSubject.getName(), lc_newSubject.getDescription());
			}
		}
		
		// Deal with removed subjects.
		Collection lc_removed = lc_datagrid.getDeletedData();
		lc_it = lc_removed.iterator();
		while (lc_it.hasNext()) {
			Subject lc_removedSubject = (Subject) lc_it.next();
			// If there is no news with this subjet, remove it.
			if (lc_database.getNewsBySubject(lc_removedSubject).isEmpty()) {
				lc_database.removeSubject(lc_removedSubject);
			}
		}
		
		// Deal with modified subjects.
		// Here the code is not very useful has the object in the database are the same as the object in the form
		// but the code is an example of how to do it.
		Collection lc_modified = lc_datagrid.getModifiedData();
		lc_it = lc_modified.iterator();
		while (lc_it.hasNext()) {
			Subject lc_modifiedSubject = (Subject) lc_it.next();
			try {
				lc_database.updateSubject(lc_modifiedSubject.getId(), lc_modifiedSubject.getName(), lc_modifiedSubject.getDescription());
			} catch (InvalidParameterException e) {
				// A subject with this name already exist.
			}
		}
		
		// Reinitialize the datagrid.
		lc_datagrid.setData(lc_database.getAllSubjects());
		
		// Forward to the jsp. 	
		return mapping.findForward("edit");
	}

}
